org.eclipse.january.dataset

## Interface CompoundDataset

- All Superinterfaces:
    Dataset, IDataset, ILazyDataset, IMetadataProvider, INameable, Serializable
  All Known Implementing Classes:
    AbstractCompoundDataset, ComplexDoubleDataset, ComplexFloatDataset, CompoundByteDataset, CompoundDoubleDataset, CompoundFloatDataset, CompoundIntegerDataset, CompoundLongDataset, CompoundShortDataset, RGBByteDataset, RGBDataset

      public interface CompoundDataset
      extends Dataset

- - ### Field Summary

    - ### Fields inherited from interface org.eclipse.january.dataset.Dataset

      `ARRAYFLOAT32, ARRAYFLOAT64, ARRAYINT16, ARRAYINT32, ARRAYINT64, ARRAYINT8, ARRAYMUL, BOOL, COMPLEX, COMPLEX128, COMPLEX64, DATE, FLOAT, FLOAT32, FLOAT64, INT, INT16, INT32, INT64, INT8, OBJECT, RGB, RGB8, serialVersionUID, STRING`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Dataset` | `asNonCompoundDataset(boolean shareData)` Get a non-compound dataset version
    `CompoundDataset` | `cast(boolean repeat, int dtype, int isize)` Cast a dataset
    `CompoundDataset` | `cast(int dtype)` Cast a dataset
    `CompoundDataset` | `clone()` Clone dataset, making new copy of data
    `void` | `copyElements(Dataset destination, int element)` Copy chosen elements from each item to another dataset
    `CompoundDataset` | `fill(Object obj)` Fill dataset with given object
    `CompoundDataset` | `flatten()` Flatten shape
    `CompoundDataset` | `getBroadcastView(int... shape)`
    `CompoundDataset` | `getBy1DIndex(IntegerDataset index)` This is modelled after the NumPy get item with an index dataset
    `CompoundDataset` | `getByBoolean(Dataset selection)` This is modelled after the NumPy get item with a condition specified by a boolean dataset
    `CompoundDataset` | `getByIndexes(Object... indexes)` This is modelled after the NumPy get item with an array of indexing objects
    `byte[]` | `getByteArray()`
    `byte[]` | `getByteArray(int... pos)`
    `byte[]` | `getByteArray(int i)`
    `byte[]` | `getByteArray(int i, int j)`
    `double[]` | `getDoubleArray()`
    `void` | `getDoubleArray(double[] darray)` Get first item as a double array
    `void` | `getDoubleArray(double[] darray, int... pos)` Get an item as a double array
    `void` | `getDoubleArray(double[] darray, int i)` Get an item as a double array
    `void` | `getDoubleArray(double[] darray, int i, int j)` Get an item as a double array
    `double[]` | `getDoubleArray(int... pos)`
    `double[]` | `getDoubleArray(int i)`
    `double[]` | `getDoubleArray(int i, int j)`
    `void` | `getDoubleArrayAbs(int index, double[] darray)` Get an item as a double array
    `Dataset` | `getElements(int element)` Get chosen elements from each item as a dataset
    `Dataset` | `getElementsView(int element)` Get chosen elements from each item as a view on dataset
    `CompoundDataset` | `getErrors()` Get the error array from the dataset of same shape.
    `float[]` | `getFloatArray()`
    `float[]` | `getFloatArray(int... pos)`
    `float[]` | `getFloatArray(int i)`
    `float[]` | `getFloatArray(int i, int j)`
    `int[]` | `getIntArray()`
    `int[]` | `getIntArray(int... pos)`
    `int[]` | `getIntArray(int i)`
    `int[]` | `getIntArray(int i, int j)`
    `long[]` | `getLongArray()`
    `long[]` | `getLongArray(int... pos)`
    `long[]` | `getLongArray(int i)`
    `long[]` | `getLongArray(int i, int j)`
    `short[]` | `getShortArray()`
    `short[]` | `getShortArray(int... pos)`
    `short[]` | `getShortArray(int i)`
    `short[]` | `getShortArray(int i, int j)`
    `CompoundDataset` | `getSlice(IMonitor mon, int[] start, int[] stop, int[] step)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(IMonitor mon, Slice... slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(IMonitor mon, SliceND slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(int[] start, int[] stop, int[] step)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(Slice... slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(SliceND slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSliceView(int[] start, int[] stop, int[] step)` Get a slice of the dataset.
    `CompoundDataset` | `getSliceView(Slice... slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSliceView(SliceND slice)` Get a slice of the dataset.
    `CompoundDataset` | `getTransposedView(int... axes)` Permute copy of dataset's axes so that given order is old order:
    `CompoundDataset` | `getView(boolean deepCopyMetadata)`
    `CompoundDataset` | `iadd(Object o)` In-place addition
    `CompoundDataset` | `idivide(Object o)` In-place division
    `CompoundDataset` | `ifloor()` In-place floor
    `CompoundDataset` | `ifloorDivide(Object o)` In-place floor division
    `CompoundDataset` | `imultiply(Object o)` In-place multiplication
    `CompoundDataset` | `ipower(Object o)` In-place raise to power of argument
    `CompoundDataset` | `iremainder(Object o)` In-place remainder of division
    `CompoundDataset` | `isubtract(Object o)` In-place subtraction
    `CompoundDataset` | `max(int axis, boolean... ignoreInvalids)`
    `double[]` | `maxItem()` Calculate maximum values of elements over all items in dataset
    `CompoundDataset` | `mean(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `min(int axis, boolean... ignoreInvalids)`
    `double[]` | `minItem()` Calculate minimum values of elements over all items in dataset
    `CompoundDataset` | `peakToPeak(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `product(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `reshape(int... shape)` Returns new dataset with new shape but old data if possible, otherwise a copy is made
    `CompoundDataset` | `rootMeanSquare(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `setBy1DIndex(Object obj, Dataset index)` This is modelled after the NumPy set item with an index dataset
    `CompoundDataset` | `setByBoolean(Object obj, Dataset selection)` This is modelled after the NumPy set item with a condition specified by a boolean dataset
    `CompoundDataset` | `setByIndexes(Object obj, Object... indexes)` This is modelled after the NumPy set item with an array of indexing objects
    `void` | `setElements(Dataset source, int element)` Set values of chosen elements from each item according to source dataset
    `CompoundDataset` | `setSlice(Object obj, IndexIterator iterator)`
    `CompoundDataset` | `setSlice(Object obj, int[] start, int[] stop, int[] step)` This is modelled after the NumPy array slice
    `CompoundDataset` | `setSlice(Object object, Slice... slice)` This is modelled after the NumPy array slice
    `CompoundDataset` | `sort(Integer axis)` In-place sort of dataset
    `CompoundDataset` | `squeeze()` Remove dimensions of 1 in shape of the dataset
    `CompoundDataset` | `squeeze(boolean onlyFromEnd)` Remove dimensions of 1 in shape of the dataset from ends only if true
    `CompoundDataset` | `squeezeEnds()` Remove dimensions of 1 from ends of shape of the dataset
    `CompoundDataset` | `stdDeviation(int axis)` Standard deviation is square root of the variance
    `CompoundDataset` | `stdDeviation(int axis, boolean isWholePopulation, boolean... ignoreInvalids)` Standard deviation is square root of the variance
    `CompoundDataset` | `sum(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `swapAxes(int axis1, int axis2)` Swap two axes in dataset
    `CompoundDataset` | `synchronizedCopy()` This is a synchronized version of the clone method
    `CompoundDataset` | `transpose(int... axes)` See `Dataset.getTransposedView(int...)`
    `CompoundDataset` | `variance(int axis)`
    `CompoundDataset` | `variance(int axis, boolean isWholePopulation, boolean... ignoreInvalids)`

    - ### Methods inherited from interface org.eclipse.january.dataset.Dataset

      `all, all, any, any, argMax, argMax, argMin, argMin, cast, cast, checkAxis, checkCompatibility, containsInfs, containsInvalidNumbers, containsNans, copy, copy, copyItemsFromAxes, count, count, count, fillDataset, get1DIndex, getBoolean, getBoolean, getBoolean, getBooleanIterator, getBooleanIterator, getBuffer, getByte, getByte, getByte, getDouble, getDouble, getDouble, getDType, getElementBooleanAbs, getElementDoubleAbs, getElementLongAbs, getError, getError, getError, getErrorArray, getErrorArray, getErrorBuffer, getFloat, getFloat, getFloat, getIndices, getInt, getInt, getInt, getIterator, getIterator, getLong, getLong, getLong, getNbytes, getNDPosition, getObject, getObject, getObject, getObjectAbs, getOffset, getPositionIterator, getRealPart, getRealView, getShapeRef, getShort, getShort, getShort, getSliceIterator, getSliceIterator, getSliceIteratorFromAxes, getStrides, getString, getString, getString, getStringAbs, getUniqueItems, hasFloatingPointElements, isCompatibleWith, isComplex, max, mean, min, overrideInternal, peakToPeak, peakToPeak, product, product, residual, residual, residual, rootMeanSquare, rootMeanSquare, set, set, set, setDirty, setErrorBuffer, setItemsOnAxes, setObjectAbs, setSlice, stdDeviation, stdDeviation, stdDeviation, stdDeviation, sum, sum, toString, variance, variance, variance, variance`

    - ### Methods inherited from interface org.eclipse.january.dataset.IDataset

      `getBoolean, getByte, getDouble, getError, getErrorArray, getFloat, getInt, getItemBytes, getLong, getMetadata, getObject, getShort, getString, max, maxPos, mean, min, minPos, resize, set, setStringFormat`

    - ### Methods inherited from interface org.eclipse.january.dataset.ILazyDataset

      `addMetadata, clearMetadata, getElementClass, getElementsPerItem, getRank, getShape, getSize, hasErrors, setErrors, setMetadata, setShape`

    - ### Methods inherited from interface org.eclipse.january.dataset.IMetadataProvider

      `getFirstMetadata, getMetadata`

    - ### Methods inherited from interface org.eclipse.january.INameable

      `getName, setName`

- - ### Method Detail

    - #### cast

          CompoundDataset cast(boolean repeat,
                               int dtype,
                               int isize)

      Description copied from interface: `Dataset`
      Cast a dataset
      Specified by:
        `cast` in interface `Dataset`
      Parameters:
        `repeat` - if true, repeat elements over item
        `dtype` - dataset type
        `isize` - item size
      Returns:
        a converted dataset

    - #### cast

          CompoundDataset cast(int dtype)

      Description copied from interface: `Dataset`
      Cast a dataset
      Specified by:
        `cast` in interface `Dataset`
      Parameters:
        `dtype` - dataset type
      Returns:
        a converted dataset

    - #### clone

          CompoundDataset clone()

      Description copied from interface: `IDataset`
      Clone dataset, making new copy of data
      Specified by:
        `clone` in interface `Dataset`
      Specified by:
        `clone` in interface `IDataset`
      Specified by:
        `clone` in interface `ILazyDataset`
      Returns:
        a (deep) copy of dataset

    - #### fill

          CompoundDataset fill(Object obj)

      Description copied from interface: `Dataset`
      Fill dataset with given object
      Specified by:
        `fill` in interface `Dataset`
      Parameters:
        `obj` - fill value
      Returns:
        filled dataset with each item being equal to the given object

    - #### flatten

          CompoundDataset flatten()

      Description copied from interface: `Dataset`
      Flatten shape
      Specified by:
        `flatten` in interface `Dataset`
      Returns:
        a flattened dataset which is a view if dataset is contiguous otherwise is a copy

    - #### getBy1DIndex

          CompoundDataset getBy1DIndex(IntegerDataset index)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy get item with an index dataset
      Specified by:
        `getBy1DIndex` in interface `Dataset`
      Parameters:
        `index` - an integer dataset
      Returns:
        The new selected dataset by indices

    - #### getByBoolean

          CompoundDataset getByBoolean(Dataset selection)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy get item with a condition specified by a boolean dataset
      Specified by:
        `getByBoolean` in interface `Dataset`
      Parameters:
        `selection` - a boolean dataset of same shape to use for selecting items
      Returns:
        The new selected dataset

    - #### getByIndexes

          CompoundDataset getByIndexes(Object... indexes)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy get item with an array of indexing objects
      Specified by:
        `getByIndexes` in interface `Dataset`
      Parameters:
        `indexes` - an array of integer dataset, boolean dataset, slices or null entries (same as full slices)
      Returns:
        The new selected dataset by index

    - #### getSlice

          CompoundDataset getSlice(IMonitor mon,
                                   int[] start,
                                   int[] stop,
                                   int[] step)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Parameters:
        `mon` - can be null
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          CompoundDataset getSlice(IMonitor mon,
                                   Slice... slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Parameters:
        `mon` - can be null
        `slice` - an array of slice objects (the array can be null or contain nulls)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          CompoundDataset getSlice(IMonitor mon,
                                   SliceND slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Parameters:
        `mon` - can be null
        `slice` - an n-D slice
      Returns:
        The dataset of the sliced data

    - #### getSlice

          CompoundDataset getSlice(int[] start,
                                   int[] stop,
                                   int[] step)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `IDataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Parameters:
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          CompoundDataset getSlice(Slice... slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `IDataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Parameters:
        `slice` - an array of slice objects (the array can be null or contain nulls)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          CompoundDataset getSlice(SliceND slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `IDataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Parameters:
        `slice` - an n-D slice
      Returns:
        The dataset of the sliced data

    - #### getSliceView

          CompoundDataset getSliceView(int[] start,
                                       int[] stop,
                                       int[] step)

      Description copied from interface: `IDataset`
      Get a slice of the dataset. The returned dataset is a view on a selection of items
      Specified by:
        `getSliceView` in interface `Dataset`
      Specified by:
        `getSliceView` in interface `IDataset`
      Specified by:
        `getSliceView` in interface `ILazyDataset`
      Parameters:
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Returns:
        The sliced view of a dataset

    - #### getSliceView

          CompoundDataset getSliceView(Slice... slice)

      Description copied from interface: `IDataset`
      Get a slice of the dataset. The returned dataset is a view on a selection of items
      Specified by:
        `getSliceView` in interface `Dataset`
      Specified by:
        `getSliceView` in interface `IDataset`
      Specified by:
        `getSliceView` in interface `ILazyDataset`
      Parameters:
        `slice` - an array of slice objects (the array can be null or contain nulls)
      Returns:
        The sliced view of a dataset

    - #### getSliceView

          CompoundDataset getSliceView(SliceND slice)

      Description copied from interface: `IDataset`
      Get a slice of the dataset. The returned dataset is a view on a selection of items
      Specified by:
        `getSliceView` in interface `Dataset`
      Specified by:
        `getSliceView` in interface `IDataset`
      Specified by:
        `getSliceView` in interface `ILazyDataset`
      Parameters:
        `slice` - an nD slice object
      Returns:
        The sliced view of a dataset

    - #### getTransposedView

          CompoundDataset getTransposedView(int... axes)

      Description copied from interface: `IDataset`
      Permute copy of dataset's axes so that given order is old order:

            axisPerm = (p(0), p(1),...) => newdata(n(0), n(1),...) = olddata(o(0), o(1), ...)
            such that n(i) = o(p(i)) for all i

      I.e. for a 3D dataset (1,0,2) implies the new dataset has its 1st dimension running along the old dataset's 2nd dimension and the new 2nd is the old 1st. The 3rd dimension is left unchanged.
      Specified by:
        `getTransposedView` in interface `Dataset`
      Specified by:
        `getTransposedView` in interface `IDataset`
      Specified by:
        `getTransposedView` in interface `ILazyDataset`
      Parameters:
        `axes` - if zero length then axes order reversed
      Returns:
        remapped view of data

    - #### getView

          CompoundDataset getView(boolean deepCopyMetadata)

      Specified by:
        `getView` in interface `Dataset`
      Parameters:
        `deepCopyMetadata` - if true then deep-copy metadata
      Returns:
        whole view of dataset (i.e. data buffer is shared)

    - #### getBroadcastView

          CompoundDataset getBroadcastView(int... shape)

      Specified by:
        `getBroadcastView` in interface `Dataset`
      Parameters:
        `shape` - to use for broadcast
      Returns:
        view of dataset that is broadcasted to given shape

    - #### iadd

          CompoundDataset iadd(Object o)

      Description copied from interface: `Dataset`
      In-place addition
      Specified by:
        `iadd` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        sum dataset

    - #### idivide

          CompoundDataset idivide(Object o)

      Description copied from interface: `Dataset`
      In-place division
      Specified by:
        `idivide` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        dividend dataset

    - #### ifloor

          CompoundDataset ifloor()

      Description copied from interface: `Dataset`
      In-place floor
      Specified by:
        `ifloor` in interface `Dataset`
      Returns:
        floored dataset

    - #### ifloorDivide

          CompoundDataset ifloorDivide(Object o)

      Description copied from interface: `Dataset`
      In-place floor division
      Specified by:
        `ifloorDivide` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        dividend dataset

    - #### imultiply

          CompoundDataset imultiply(Object o)

      Description copied from interface: `Dataset`
      In-place multiplication
      Specified by:
        `imultiply` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        product dataset

    - #### ipower

          CompoundDataset ipower(Object o)

      Description copied from interface: `Dataset`
      In-place raise to power of argument
      Specified by:
        `ipower` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        raised dataset

    - #### iremainder

          CompoundDataset iremainder(Object o)

      Description copied from interface: `Dataset`
      In-place remainder of division
      Specified by:
        `iremainder` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        remaindered dataset

    - #### isubtract

          CompoundDataset isubtract(Object o)

      Description copied from interface: `Dataset`
      In-place subtraction
      Specified by:
        `isubtract` in interface `Dataset`
      Parameters:
        `o` - object to use
      Returns:
        difference dataset

    - #### reshape

          CompoundDataset reshape(int... shape)

      Description copied from interface: `Dataset`
      Returns new dataset with new shape but old data if possible, otherwise a copy is made
      Specified by:
        `reshape` in interface `Dataset`
      Parameters:
        `shape` - new shape
      Returns:
        reshaped dataset

    - #### setBy1DIndex

          CompoundDataset setBy1DIndex(Object obj,
                                       Dataset index)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with an index dataset
      Specified by:
        `setBy1DIndex` in interface `Dataset`
      Parameters:
        `obj` - specifies the object used to set the selected items
        `index` - an integer dataset
      Returns:
        The dataset with modified content

    - #### setByBoolean

          CompoundDataset setByBoolean(Object obj,
                                       Dataset selection)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with a condition specified by a boolean dataset
      Specified by:
        `setByBoolean` in interface `Dataset`
      Parameters:
        `obj` - specifies the object used to set the selected items
        `selection` - a boolean dataset of same shape to use for selecting items
      Returns:
        The dataset with modified content

    - #### setByIndexes

          CompoundDataset setByIndexes(Object obj,
                                       Object... indexes)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with an array of indexing objects
      Specified by:
        `setByIndexes` in interface `Dataset`
      Parameters:
        `obj` - specifies the object used to set the selected items
        `indexes` - an array of integer dataset, boolean dataset, slices or null entries (same as full slices)
      Returns:
        The dataset with modified content

    - #### setSlice

          CompoundDataset setSlice(Object obj,
                                   IndexIterator iterator)

      Specified by:
        `setSlice` in interface `Dataset`
      Parameters:
        `obj` - specifies the object used to set the specified slice
        `iterator` - specifies the slice iterator
      Returns:
        this

    - #### setSlice

          CompoundDataset setSlice(Object obj,
                                   int[] start,
                                   int[] stop,
                                   int[] step)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy array slice
      Specified by:
        `setSlice` in interface `Dataset`
      Parameters:
        `obj` - specifies the object used to set the specified slice
        `start` - specifies the starting indexes
        `stop` - specifies the stopping indexes (nb, these are not included in the slice)
        `step` - specifies the steps in the slice
      Returns:
        this

    - #### setSlice

          CompoundDataset setSlice(Object object,
                                   Slice... slice)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy array slice
      Specified by:
        `setSlice` in interface `Dataset`
      Parameters:
        `object` - specifies the object used to set the specified slice
        `slice` - destination where items of obj are set
      Returns:
        this

    - #### sort

          CompoundDataset sort(Integer axis)

      Description copied from interface: `Dataset`
      In-place sort of dataset
      Specified by:
        `sort` in interface `Dataset`
      Parameters:
        `axis` - to sort along. If null, then the flattened view is sorted
      Returns:
        sorted dataset

    - #### squeezeEnds

          CompoundDataset squeezeEnds()

      Description copied from interface: `ILazyDataset`
      Remove dimensions of 1 from ends of shape of the dataset
      Specified by:
        `squeezeEnds` in interface `Dataset`
      Specified by:
        `squeezeEnds` in interface `IDataset`
      Specified by:
        `squeezeEnds` in interface `ILazyDataset`
      Returns:
        this

    - #### squeeze

          CompoundDataset squeeze()

      Description copied from interface: `IDataset`
      Remove dimensions of 1 in shape of the dataset
      Specified by:
        `squeeze` in interface `Dataset`
      Specified by:
        `squeeze` in interface `IDataset`
      Returns:
        this

    - #### squeeze

          CompoundDataset squeeze(boolean onlyFromEnd)

      Description copied from interface: `IDataset`
      Remove dimensions of 1 in shape of the dataset from ends only if true
      Specified by:
        `squeeze` in interface `Dataset`
      Specified by:
        `squeeze` in interface `IDataset`
      Parameters:
        `onlyFromEnd` - if true, trim ends
      Returns:
        this

    - #### swapAxes

          CompoundDataset swapAxes(int axis1,
                                   int axis2)

      Description copied from interface: `Dataset`
      Swap two axes in dataset
      Specified by:
        `swapAxes` in interface `Dataset`
      Parameters:
        `axis1` - to swap
        `axis2` - to swap
      Returns:
        swapped view of dataset

    - #### synchronizedCopy

          CompoundDataset synchronizedCopy()

      Description copied from interface: `Dataset`
      This is a synchronized version of the clone method
      Specified by:
        `synchronizedCopy` in interface `Dataset`
      Returns:
        a copy of dataset

    - #### transpose

          CompoundDataset transpose(int... axes)

      Description copied from interface: `Dataset`
      See `Dataset.getTransposedView(int...)`
      Specified by:
        `transpose` in interface `Dataset`
      Parameters:
        `axes` - if zero length then axes order reversed
      Returns:
        remapped copy of data

    - #### max

          CompoundDataset max(int axis,
                              boolean... ignoreInvalids)

      Specified by:
        `max` in interface `Dataset`
      Parameters:
        `axis` - to reduce over
        `ignoreInvalids` - - Can be null, empty, or one or more booleans. By default, all booleans are false. If the first boolean is true, will ignore NaNs and ignore infinities. Use the second boolean to ignore infinities separately.
      Returns:
        maxima along axis in dataset
      Since:
        2.0

    - #### min

          CompoundDataset min(int axis,
                              boolean... ignoreInvalids)

      Specified by:
        `min` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        minima along axis in dataset
      Since:
        2.0

    - #### peakToPeak

          CompoundDataset peakToPeak(int axis,
                                     boolean... ignoreInvalids)

      Specified by:
        `peakToPeak` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        peak-to-peak dataset, the difference of maxima and minima of dataset along axis
      Since:
        2.0

    - #### sum

          CompoundDataset sum(int axis,
                              boolean... ignoreInvalids)

      Specified by:
        `sum` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        sum along axis in dataset
      Since:
        2.0

    - #### product

          CompoundDataset product(int axis,
                                  boolean... ignoreInvalids)

      Specified by:
        `product` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        product along axis in dataset
      Since:
        2.0

    - #### mean

          CompoundDataset mean(int axis,
                               boolean... ignoreInvalids)

      Specified by:
        `mean` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        mean along axis in dataset
      Since:
        2.0

    - #### rootMeanSquare

          CompoundDataset rootMeanSquare(int axis,
                                         boolean... ignoreInvalids)

      Specified by:
        `rootMeanSquare` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        root mean square along axis in dataset
      Since:
        2.0

    - #### stdDeviation

          CompoundDataset stdDeviation(int axis)

      Description copied from interface: `Dataset`
      Standard deviation is square root of the variance
      Specified by:
        `stdDeviation` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
      Returns:
        standard deviation along axis in dataset
      See Also:
        `with isWholePopulation = false`

    - #### stdDeviation

          CompoundDataset stdDeviation(int axis,
                                       boolean isWholePopulation,
                                       boolean... ignoreInvalids)

      Description copied from interface: `Dataset`
      Standard deviation is square root of the variance
      Specified by:
        `stdDeviation` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `isWholePopulation` - if false, consider as sample of population
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        standard deviation along axis in dataset
      Since:
        2.0

    - #### variance

          CompoundDataset variance(int axis)

      Specified by:
        `variance` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
      Returns:
        sample variance along axis in dataset
      See Also:
        `with isWholePopulation = false`

    - #### variance

          CompoundDataset variance(int axis,
                                   boolean isWholePopulation,
                                   boolean... ignoreInvalids)

      Specified by:
        `variance` in interface `Dataset`
      Parameters:
        `axis` - to reduce along
        `isWholePopulation` - if false, consider as sample of population
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        sample variance along axis in dataset
      Since:
        2.0

    - #### getDoubleArray

          void getDoubleArray(double[] darray)

      Get first item as a double array
      Parameters:
        `darray` - double array must be allocated and have sufficient length
      Since:
        2.0

    - #### getDoubleArray

          void getDoubleArray(double[] darray,
                              int i)

      Get an item as a double array
      Parameters:
        `darray` - double array must be allocated and have sufficient length
        `i` - position in first dimension

    - #### getDoubleArray

          void getDoubleArray(double[] darray,
                              int i,
                              int j)

      Get an item as a double array
      Parameters:
        `darray` - double array must be allocated and have sufficient length
        `i` - position in first dimension
        `j` - position in second dimension

    - #### getDoubleArray

          void getDoubleArray(double[] darray,
                              int... pos)

      Get an item as a double array
      Parameters:
        `darray` - double array must be allocated and have sufficient length
        `pos` - position

    - #### getDoubleArrayAbs

          void getDoubleArrayAbs(int index,
                                 double[] darray)

      Get an item as a double array
      Parameters:
        `index` - in array
        `darray` - double array must be allocated and have sufficient length

    - #### getElements

          Dataset getElements(int element)

      Get chosen elements from each item as a dataset
      Parameters:
        `element` - to choose
      Returns:
        dataset of chosen elements

    - #### getElementsView

          Dataset getElementsView(int element)

      Get chosen elements from each item as a view on dataset
      Parameters:
        `element` - to choose
      Returns:
        view dataset of chosen elements

    - #### setElements

          void setElements(Dataset source,
                           int element)

      Set values of chosen elements from each item according to source dataset
      Parameters:
        `source` - dataset
        `element` - to choose

    - #### copyElements

          void copyElements(Dataset destination,
                            int element)

      Copy chosen elements from each item to another dataset
      Parameters:
        `destination` - dataset
        `element` - to choose

    - #### asNonCompoundDataset

          Dataset asNonCompoundDataset(boolean shareData)

      Get a non-compound dataset version
      Parameters:
        `shareData` - if true, then share data when possible otherwise copy it
      Returns:
        non-compound dataset

    - #### maxItem

          double[] maxItem()

      Calculate maximum values of elements over all items in dataset
      Returns:
        double array of element-wise maxima

    - #### minItem

          double[] minItem()

      Calculate minimum values of elements over all items in dataset
      Returns:
        double array of element-wise minima

    - #### getErrors

          CompoundDataset getErrors()

      Description copied from interface: `Dataset`
      Get the error array from the dataset of same shape. This will create a new dataset if the error set was of lower rank
      Specified by:
        `getErrors` in interface `Dataset`
      Specified by:
        `getErrors` in interface `IDataset`
      Specified by:
        `getErrors` in interface `ILazyDataset`
      Returns:
        the dataset which contains the error information (can be null)
      Since:
        2.0

    - #### getByteArray

          byte[] getByteArray()

      Returns:
        item in first position
      Since:
        2.0

    - #### getByteArray

          byte[] getByteArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getByteArray

          byte[] getByteArray(int i,
                              int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getByteArray

          byte[] getByteArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getShortArray

          short[] getShortArray()

      Returns:
        item in first position
      Since:
        2.0

    - #### getShortArray

          short[] getShortArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getShortArray

          short[] getShortArray(int i,
                                int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getShortArray

          short[] getShortArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getIntArray

          int[] getIntArray()

      Returns:
        item in first position
      Since:
        2.0

    - #### getIntArray

          int[] getIntArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getIntArray

          int[] getIntArray(int i,
                            int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getIntArray

          int[] getIntArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position
      Since:
        2.0

    - #### getLongArray

          long[] getLongArray()

      Returns:
        item in first position
      Since:
        2.0

    - #### getLongArray

          long[] getLongArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getLongArray

          long[] getLongArray(int i,
                              int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getLongArray

          long[] getLongArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getFloatArray

          float[] getFloatArray()

      Returns:
        item in first position
      Since:
        2.0

    - #### getFloatArray

          float[] getFloatArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getFloatArray

          float[] getFloatArray(int i,
                                int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getFloatArray

          float[] getFloatArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getDoubleArray

          double[] getDoubleArray()

      Returns:
        item in first position
      Since:
        2.0

    - #### getDoubleArray

          double[] getDoubleArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getDoubleArray

          double[] getDoubleArray(int i,
                                  int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getDoubleArray

          double[] getDoubleArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

Copyright © 2014–2022 Eclipse Foundation. All rights reserved.